-- Unlimited number body
-- You may use and modify this file free
-- without deleting this comment group
-- Copyright (c) 1999 Dimitriy Anisimkov
-- e-mail anisimkov@yahoo.com
with Ada.Strings.Fixed,Ada.Strings;
package body Unlimited.Dynamic is
   use DynUnlim;

   procedure Divide(Numerator,Denominator : in Unbounded_Number;
         Result,Remainder : out Unbounded_Number) is
      A1 : Unlimited_Static renames GetAccess(Numerator).all;      
      A2 : Unlimited_Static renames GetAccess(Denominator).all;      
      Res : Unlimited_Static(0..Integer'Max(A1'Last-A2'First+1,0));
      Remain : Unlimited_Static(Integer'Min(A1'First,A2'First)..Integer'Min(A1'Last,A2'Last)+1);
   begin
      Divide(A1,A2,Res,Remain);
      Result := Create(Res);
      Remainder := Create(Remain);
   end;
   
   function To_String(Num : in Unbounded_Number; 
         Base : Base_Of_Presentation :=10) return String is
   begin
      return To_String(GetAccess(Num).all,Base);
   end;
   
   function To_String(Num : in Unbounded_Number; 
         Base : Conversion_Chars) return String is
   begin
      return To_String(GetAccess(Num).all,Base);
   end;
   
   -- only decimal now
   function To_Unbounded_Number(S : String) return Unbounded_Number is
      Base : constant Base_Of_Presentation :=10;
      Pos0 : constant := Character'Pos('0');
      Result : Unbounded_Number;
      Use Ada.Strings;
      St : String := Fixed.Trim(S,Both);
      StFirst : Integer := St'First;
      Sign : Boolean := St(St'First)='-';
   begin
      if Sign then
         StFirst := StFirst+1;
      end if;
      for I in StFirst..St'Last loop
         if St(I) not in '0'..'9' then
           raise Wrong_Symbol;
         end if;
         Result := Result*Base+Create((0 => Character'Pos(St(I))-Pos0));
      end loop;
      if Sign then
         return -Result;  
      else 
         return Result;
      end if;  
   end;

end Unlimited.Dynamic;